/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
var app = {
    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicity call 'app.receivedEvent(...);'
    onDeviceReady: function() {
        //app.receivedEvent('deviceready');
    	document.addEventListener("online", app.toggleCon, false);
    	document.addEventListener("offline", app.toggleCon, false);
    	document.addEventListener("backbutton", app.onBackKeyDown, false);
        
        $.mobile.allowCrossDomainPages = true;
        $.mobile.zoom.enabled = false;
        $.mobile.buttonMarkup.hoverDelay = 0; //defaults 200
        $.mobile.defaultDialogTransition = 'none';
        $.mobile.useFastClick = true;
        $.support.cors = true;
        
        //Instancia del productMgr 
    	productMgr = new ProductMgr();
        
        if (device.platform === 'iOS' || device.platform === 'ios' || device.platform === 'IOS') {
        	$.mobile.defaultPageTransition = 'slide';
		}else{
			$.mobile.defaultPageTransition = 'none';
			
			//Hide splash
	    	app.hideSplash();
		}
    },
    // online / offline Event Handler
    toggleCon: function(e) {
        
    	if (e.type == 'online') {
    		
    		if (!connectionOk) {
    			
    			notification('Ya tienes internet!','Con conexión','Aceptar');
    		}
    		connectionOk = true;
    		
    	} else {
    		
    		if (connectionOk) {
    			connectionOk = false;
    			notification('Oops, revisa tu internet!','Sin conexión','Aceptar');
    		}
    	}
    },
    //Handle the back button
    onBackKeyDown: function() {
    	
    	$.mobile.loading("show");
    	
    	var active_page = $.mobile.activePage.attr("id");
    	
    	if (active_page == 'prodListPage') {
    		
    		goTo('categories.html', true);
    		
    	} else if (active_page == 'orderSummary') {
    		
    		goTo('productsList.html', true);
			
		} else if (active_page == 'finishOrder') {
			
			goTo('orderSummary.html', true);
			
		} else if (active_page == 'termsPage') {
			
			history.back();
			
		} else if (device.platform == 'Android' || device.platform == 'android') {
    		
    		notiExit();		
    	}
    },
    // Update DOM on a Received Event
    receivedEvent: function(id) {
        //alert("Event: "+id);
    },
    hideSplash: function(){
    	
    	try {
    		//Hide the splash screen when ready
        	navigator.splashscreen.hide();
		} catch (e) {
			// TODO: handle exception
		}
    }
};
