/* Product obj */
function ProductMgr(){
	
	//To have access from methods
	var productObj = this;
	
	//Public properties
	this.productIds = null;
	this.showProducts = null;
	this.itemsOrder = null;
	this.itemsCount = 0;
	this.orderValue = 0;
	this.minOrderValue = 0;
	this.shippingCost = 0;
	this.successOrder = false;
	this.plusTen = false; //Para saber cuando cambiar el estilo de la cuenta de productos
	this.category = null;
				
	//**************************************** Public Methods ****************************************************//
	/**
	 * Reviso si han cambiado los productos en el servidor
	 */
	this.checkProducts = function(){

		window.localStorage.setItem("categoriesId", '-1');
		window.localStorage.setItem("itemsId", '-1');
		
		//Ajax call
		$.post( url+'apparty/apparty.php', 
				{action: "checkProducts",
				 city: window.localStorage.getItem("city")})
			.done( function(json) {
				  
				if (json.success) {
							
					//Get the minimum order value and the shipping cost
					window.localStorage.setItem("minOrderValue", json.minOrderValue);
					productMgr.minOrderValue = json.minOrderValue;
					window.localStorage.setItem("shippingCost", json.shippingCost);
					productMgr.shippingCost = json.shippingCost;
					
					if(window.localStorage.getItem("categoriesId") != json.categoriesId){
						
						window.localStorage.setItem("categoriesId", json.categoriesId);
						productMgr.updateCategories(json.itemsId);
						
					}else if(window.localStorage.getItem("itemsId") != json.itemsId){
						
						window.localStorage.setItem("itemsId", json.itemsId);
						productMgr.updateProducts();
						
					}else{
						goHome();
					}
				}
		    })
		    .fail( function(xhr, textStatus, errorThrown) {
		    	
		    	//alert('falla: '+xhr.responseText+' // '+textStatus+' // '+errorThrown);
		    	
		    	setTimeout(function(){
					
					productMgr.checkProducts();
					
				}, 1500);
		    });
		/*
		setTimeout(function(){
			
			$.mobile.changePage( "html/categories.html", { transition: "fade" });
			
		}, 3000);*/
	};
	
	/**
	 * Actualizo el XML con las categorias
	 */
	this.updateCategories = function(itemsId){

		//Obtengo la ciudad que el usuario escogio
		var city = window.localStorage.getItem("city");
				
		$.ajax({
		    type: "GET",
		    url: url+"apparty/categories"+city+".xml?time="+new Date().getTime(),
		    dataType: "xml",
		    cache: false,
		    success: function(xml) {
		        
		    	window.localStorage.setItem("categoriesXml", new XMLSerializer().serializeToString(xml));
		    	
		    	if(window.localStorage.getItem("itemsId") != itemsId){
					
					window.localStorage.setItem("itemsId", itemsId);
					productMgr.updateProducts();
					
				}else{
					
					goHome();
					/*
					setTimeout(function(){
						
						$.mobile.changePage( 'categories'+window.localStorage.getItem("city")+'.html', {transition: 'fade'} );
						
					}, 1000);*/
				}
		    },
		    error: function(err) {
		    	//alert('err');
		    	setTimeout(function(){
					
					productMgr.updateCategories(itemsId);
					
				}, 1500);
		    }
		  });
	};
	/**
	 * Actualizo el XML con los productos
	 */
	this.updateProducts = function(){

		//Obtengo la ciudad que el usuario escogio
		var city = '';
		if (window.localStorage.getItem("city") != 'Cali') {
			city = window.localStorage.getItem("city");
		}
		
		$.ajax({
		    type: "GET",
		    url: url+"apparty/products"+city+".xml?time="+new Date().getTime(),
		    dataType: "xml",
		    cache: false,
		    success: function(xml) {
		        
		    	//alert(new XMLSerializer().serializeToString(xml));
		    	
		    	window.localStorage.setItem("xml", new XMLSerializer().serializeToString(xml));
		    	
		    	goHome();
		    	
		    	//$.mobile.changePage( 'categories'+window.localStorage.getItem("city")+'.html', {transition: 'fade'} );
		    },
		    error: function(err) {
		    	setTimeout(function(){
		    		productMgr.updateProducts();
		    	}, 1500);
		    }
		  });
	};
	/**
	 * Muestra los productos de una categoria
	 */
	this.getCategory = function(category){
		
		productMgr.category = category;
		
		$.mobile.changePage( "productsList.html" );
	};
	/**
	 * Muestra los productos de una categoria
	 */
	this.getProducts = function(){

		productMgr.showProducts = '<ul data-role="listview" data-inset="true" data-theme= "a" data-split-icon="plus" class="div-padding">';
		
		var xml =  window.localStorage.getItem("xml");
		/*
		var xml= '<categories>\
					<Aguardiente>\
						<item>\
							<description>Blanco del Valle botella 750ml</description>\
							<img>aguardiente_1.png</img>\
							<price>26000</price>\
						</item>\
					</Aguardiente>\
					<Brandy>\
					    <item>\
							<description>Domecq caneca 375ml</description>\
							<img>brandy_1.png</img>\
							<price>19000</price>\
						</item>\
						<item>\
							<description>Domecq botella 750ml</description>\
							<img>brandy_2.png</img>\
							<price>32000</price>\
						</item>\
						<item>\
							<description>5 Estrellas caneca 375ml</description>\
							<img>brandy_3.png</img>\
							<price>18000</price>\
						</item>\
						<item>\
							<description>5 Estrellas botella 750ml</description>\
							<img>brandy_4.png</img>\
							<price>30000</price>\
						</item>\
					</Brandy>\
				</categories>';*/
	
	    xmlDoc = $.parseXML( xml );
	    $xml = $( xmlDoc );
	    $xml.find(productMgr.category).children().each(function(){
	    	
	    	//alert($(this).find('name').text());
	    	productMgr.showProducts += '<li>'+
											'<a href="#">'+
												'<img src="'+url+'apparty/products/'+$(this).find('img').text()+'" />'+
												'<h3>'+$(this).find('description').text().replace(/\\/g,"")+'</h3>'+
												'<p>Precio: '+$(this).find('price').text()+'</p>'+
											'</a><a href="#" onclick="productMgr.addProduct(\''+$(this).find('description').text()+'\', '+$(this).find('price').text()+',\''+$(this).find('img').text()+'\'); return false" rel="external">Agregar al carrito</a>'+
										'</li>';
	    });
	    
	    productMgr.showProducts += '</ul>';
	    
	    //console.log( productMgr.showProducts);
	    /*	
	    $("#productListDiv div .iscroll-content").append(productMgr.showProducts+'<br><br>');
	    $('[data-role="content"]').trigger('create');
	    $("#productListDiv").iscrollview("refresh");
	    */
	    $('#productListDiv').html(productMgr.showProducts+'<br><br>').trigger('create');
	    
	    $('.ui-page').css('height', ($('[data-role="content"]').height()+70)+'px').trigger('create');
	    
	    //$.mobile.changePage( "productsList.html", { transition: "slide" });
	};	
	
	/**
	 * Agrega producto al pedido
	 */
	this.addProduct = function(description, price, img){
		
		productMgr.itemsCount += 1;
		
		if (productMgr.itemsOrder == null) {
			
			productMgr.itemsOrder = new Array();
			
			$('.basket').css('visibility', 'visible').append('<span class="basketCount">'+productMgr.itemsCount+'</span>');
						
		}else{
			$('.basketCount').empty().html(productMgr.itemsCount);
			
			if (productMgr.itemsCount >= 10 && !productMgr.plusTen) {
				$('.basketCount').css('right', '10px');
				productMgr.plusTen = true;
			}
		}
		
		if (productMgr.itemsOrder[img] === undefined) {
			
			var itemArray = {img: img, price: price, description: description, quantity: 1};
						
			productMgr.itemsOrder[img] = itemArray;
			
		}else{
			productMgr.itemsOrder[img]['quantity'] += 1;
		}		
		
		productMgr.orderValue += price;
		
		$('.totalPrice').empty();
		
		setTimeout(function(){
			$('.totalPrice').html(productMgr.orderValue);
		}, 500);
		//$('.basket').fadeOut('fast').fadeIn('fast');
	};
	
	/**
	 * Elimina una unidad de un producto
	 */
	this.removeProduct = function(price, img){
		
		productMgr.itemsCount -= 1;
		var itemDiv = img.split('/')[1].split(".")[0];
		
		if(productMgr.itemsCount < 1){
			
			productMgr.newOrder();
			
		}else{
			
			if (productMgr.itemsOrder[img]['quantity'] == 1) {
				
				$('#orderSummaryDiv').css('min-height', $('#orderSummaryDiv').height()+'px');
				
				delete productMgr.itemsOrder[img];
				
				$("#"+itemDiv+"_li").remove();
				
				$('#orderList').listview('refresh');
								
			} else {
				productMgr.itemsOrder[img]['quantity'] -= 1;
				
				$("#"+itemDiv+"_quantity").empty().html(productMgr.itemsOrder[img]['quantity']);
			}
			
			productMgr.orderValue = productMgr.orderValue - price;
			
			//$('.basketCount').html(productMgr.itemsCount);
			
			//$('#totalPrice').html('<p><strong>Total: '+productMgr.orderValue+'</strong></p>');
			
			if (productMgr.itemsCount < 10) {
				productMgr.plusTen = false;
			}
			
			$('.totalPrice').empty();
			
			setTimeout(function(){
				$('.totalPrice').html(productMgr.orderValue);
			}, 600);
		}
	};
	
	/**
	 * Resumen del pedido
	 */
	this.orderSummary = function(){
		
		var html = '<ul id="orderList" data-role="listview" data-inset="true" data-theme="a" data-split-icon="delete">';
		var itemDiv = "";	
		
		//var html = '<div class="roundedCorners">'
		//productMgr.orderValue = 0;
		for(key in productMgr.itemsOrder) { 
			//alert("key " + key + " has value " + productMgr.itemsOrder[key]['quantity']); 
			//productMgr.orderValue += productMgr.itemsOrder[key]['quantity'] * productMgr.itemsOrder[key]['price'];
			
			itemDiv = productMgr.itemsOrder[key]['img'].split('/')[1].split(".")[0];
			
			html += '<li id="'+itemDiv+'_li">'+
						'<a href="#">'+
							'<img src="'+url+'apparty/products/'+productMgr.itemsOrder[key]['img']+'" />'+
							'<h3>'+productMgr.itemsOrder[key]['description']+'</h3>'+
							'<p>Precio/und: '+productMgr.itemsOrder[key]['price']+'</p>'+
							'<p>Cantidad: <span id="'+itemDiv+'_quantity">'+productMgr.itemsOrder[key]['quantity']+'</span></p>'+
						'</a><a href="#" onclick="productMgr.removeProduct('+productMgr.itemsOrder[key]['price']+',\''+productMgr.itemsOrder[key]['img']+'\'); return false" rel="external">Quitar</a>'+
					'</li>';					
		}
		
		html += '</ul>';
		
		
		//console.log(html);
		/*
		$("#orderSummaryDiv div .iscroll-content").append('<div class="div-padding"><div id="orderSummaryList">'+html+'</div>'+
														  '<a id="continueOrder" href="#" data-role="button" onclick="notiShipping(); return false" rel="external" class="green-btn">CONTINUAR</a></div><br>');
	    $('[data-role="content"]').trigger('create');
	    $("#orderSummaryDiv").iscrollview("refresh");
	    */
		$('#orderSummaryDiv').html('<div class="div-padding"><div id="orderSummaryList">'+html+'</div>'+
				  					'<a id="continueOrder" href="#" data-role="button" onclick="notiShipping(); return false" rel="external" class="green-btn">CONTINUAR</a></div><br>').trigger('create');
		
		$('.ui-page').css('height', ($('[data-role="content"]').height()+70)+'px').trigger('create');
		
		$('.totalPrice').html(productMgr.orderValue);
		
	};
	/**
	 * Finalizo el pedido
	 */
	this.finishOrder = function(){

		if (jsonSchedule == null) {
			
			var username = $("#txtUserName").val();
			var phone = $("#txtPhone").val();
			var address = $("#txtAddress").val();
			
			if (username !== "" && phone !== "" && address !== "") {
				
				//Check the phone number
				var okFinish = false;
				try {
					
					if (phone.length == 10 && productMgr.isNumberOnly(phone)) {
						
						okFinish = true;
					}else{
						notification('Revisa el # de celular.', 'Aviso', 'Aceptar');
					}
				} catch (e) {
					// TODO: handle exception
				}
				
				if (okFinish) {
					
					window.localStorage.setItem("username", username);
					window.localStorage.setItem("phone", phone);
					window.localStorage.setItem("address", address);
					
					var html = "";
					var total = 0;
					for(key in productMgr.itemsOrder) { 
						
						total += productMgr.itemsOrder[key]['quantity'] * productMgr.itemsOrder[key]['price'];
						
						html += '<p><span>Articulo: '+productMgr.itemsOrder[key]['description']+'</span><br>'+
								 '<span>Precio/und: '+productMgr.itemsOrder[key]['price']+'</span><br>'+
								 '<span>Cantidad: '+productMgr.itemsOrder[key]['quantity']+'</span></p>';		
					}
					
					html += '<p><strong>Valor total: '+total+'</strong></p>';
					
					$.mobile.loading("show", {
						text: 'Finalizando pedido',
						textVisible: true,
						theme: 'a'
					});
					
					//Ajax call
					$.post( url+'apparty/apparty.php', 
							{action: "finishOrder",
							 html: html,
							 username: username,
							 phone: phone,
							 address: address,
							 city: window.localStorage.getItem("city")})
						.done( function(json) {
							  
							$.mobile.loading('hide');
							
							if (json.success) {
								
								productMgr.successOrder = true;
								productMgr.newOrder();
								//notification('Hemos recibido tu pedido, en unos minutos te llamaremos para confirmar.', 'Aviso', 'Aceptar');
								
								notiSuccessOrder(json.msg);
								
								goHome();
								
								//goTo('orderSummary.html', true);
								
							}
					    })
					    .fail( function(xhr, textStatus, errorThrown) {
					    	
					    	
					    });
				}
				
			}else{
				notification('Todos los campos son obligatorios', 'Aviso', 'Aceptar');
			}
			
		}else{
			showSchedulePop(jsonSchedule);
		}		
	};
	
	/**
	 * Nuevo del pedido
	 */
	this.newOrder = function(){
		
		productMgr.itemsOrder = null;
		productMgr.successOrder = false;
		productMgr.orderValue = 0;
		productMgr.itemsCount = 0;
		
		$('.totalPrice').html('0');
		
		goTo('categories'+window.localStorage.getItem("city")+'.html', true);
	};
	
	/**
	 * Verifico si el valor es solo numerico
	 */
	this.isNumberOnly = function (value) {
	    var regExp = "^\\d+$";
	    return value.match(regExp); 
	}
	
	/**
	 * Asigno la ciudad del usuario
	 */
	this.setCity = function(city){
		
		window.localStorage.setItem("city", city);
		
		//Clear all
		if (productMgr != null) {
			productMgr.itemsOrder = null;
			productMgr.successOrder = false;
			productMgr.orderValue = 0;
			productMgr.itemsCount = 0;
			
			$('.totalPrice').html('0');
		}
		
		$.mobile.changePage("loading.html");
	};
	
	/**
	 * Ingreso por primera vez a la app
	 */
	this.enterApp = function(){
		
		var city = $('#select-city').val();
		
		if (city != null && city != undefined && city != '') {
			
			window.localStorage.setItem("city", city);
			
			//Clear all
			if (productMgr != null) {
				productMgr.itemsOrder = null;
				productMgr.successOrder = false;
				productMgr.orderValue = 0;
				productMgr.itemsCount = 0;
				
				$('.totalPrice').html('0');
			}
			
			$.mobile.changePage("loading.html");
		}else{
			notification('Selecciona una ciudad.', 'Aviso', 'Aceptar');
		}
	};
}